﻿/*---------------------------------------------------------------------------//
 RAWR - Player v1.0.0 - Buttons

 © 2007-2009, RAWR-Designs, Some Rights Reserved -
	Christopher "That Stevens Guy" Stevens
	Richard "Giant Eagle" Tuininga
 (CC) http://creativecommons.org/licenses/by-nc-sa/3.0/

 Any queries? -
	Email: contact[at]rawr-designs[dot]com
	Forum: http://www.rawr-designs.com/forum/
 	Homepage: http://www.rawr-designs.com
//---------------------------------------------------------------------------*/

/*---------------------------------------------------------------------------//
 Controls Pause/Play icon.
//---------------------------------------------------------------------------*/
function playPauseSwap(iconSet) {
	if(iconSet == "play") {
		fadeFunc(gui.progressBar.playStatus,"out",50);
		gui.playPauseBtn.playIcon._visible = bigBtn.playIcon._visible = bigBtn._visible = true;
		gui.playPauseBtn.pauseIcon._visible = bigBtn.pauseIcon._visible = false;
	} else {
		fadeFunc(gui.progressBar.playStatus,"in",100);
		gui.playPauseBtn.playIcon._visible = bigBtn.playIcon._visible = bigBtn._visible = false;
		gui.playPauseBtn.pauseIcon._visible = bigBtn.pauseIcon._visible = true;
	}
}
/*---------------------------------------------------------------------------//
 Add some functionality to the mouse and the keyboard.
//---------------------------------------------------------------------------*/
var doubleClickDuration = 300;
var lastClick = 0;
var keyListener = new Object();
Key.addListener(keyListener);
keyListener.onKeyDown = function() {
	if(Key.getCode() == 32 && Stage.displayState == "fullScreen") playPauseFunc();
}
overlay.onRollOver = function() {
	bigBtn._visible = true;
}
overlay.onRollOut = function() {
	if(pbStatus == "play" && pbStatus != "buffering") bigBtn._visible = false;
}
overlay.onRelease = overlay.onReleaseOutside = function() {
  if(this.hitTest(this._xmouse, this._ymouse, true)) {
    if(lastClick == 0) {
      lastClick = getTimer();
    } else {
      lastClick = 0;
      Stage.displayState == "normal" ? Stage.displayState = "fullScreen" : Stage.displayState = "normal";
    }
  }
}
// TODO: [IMPROVEMENT] use setTimeout instead of onEnterFrame
overlay.onEnterFrame = function() {
  if(lastClick > 0) {
    if((getTimer() - lastClick) > doubleClickDuration) {
      lastClick = 0;
      playPauseFunc();
    }
  }
}
/*---------------------------------------------------------------------------//
 onRelease for all buttons.
//---------------------------------------------------------------------------*/
playPauseFunc = gui.playPauseBtn.onRelease = function() {
	if(pbStatus != "buffering") {
		if(gui.playPauseBtn.playIcon._visible == true) {
			if(pbStatus != "end") pbStatus = "play";
			playPauseSwap();
			b = this.pauseIcon;
		} else {
			pbStatus = "pause";
			playPauseSwap("play");
			b = this.playIcon;
		}
		initMedia();
		iconColor();
	}
}
gui.stopBtn.onRelease = function() {
	pos = 0;
	pbStatus = "stop";
	initMedia();
	playPauseSwap("play");
	counterActive = false;
}
gui.nextBtn.onRelease = function() {
	changeMedia("next");
}
gui.prevBtn.onRelease = function() {
	changeMedia("prev");
}
gui.viewBtn.onRelease = function () {
	Stage.displayState == "normal" ? Stage.displayState = "fullScreen" : Stage.displayState = "normal";
}
gui.methodBtn.onRelease = function() {
	switch(playmethod) {
		case "single":
			playmethod = "loop";
			gui.tt.txt = "Loop Play";
			this.singleIcon._visible = false;
			this.loopIcon._visible = true;
			b = this.loopIcon;
		break;
		case "loop":
			if(mode != "full") {
				playmethod = "single";
				gui.tt.txt = "Single Play";
				this.singleIcon._visible = true;
				this.loopIcon._visible = false;
				b = this.singleIcon;
			} else {
				playmethod = "list";
				gui.tt.txt = "List Play";
				this.loopIcon._visible = false;
				this.listIcon._visible = true;
				b = this.listIcon;
			}
		break;
		case "list":
			playmethod = "shuffle";
			gui.tt.txt = "Shuffle";
			this.shuffleIcon._visible = true;
			this.listIcon._visible = false;
			b = this.shuffleIcon;
		break;
		case "shuffle":
			playmethod = "single";
			gui.tt.txt = "Single Play";
			this.singleIcon._visible = true;
			this.shuffleIcon._visible = false;
			b = this.singleIcon;
		break;
	}
	iconColor();
	ExternalInterface.call("playbackMethod", playmethod);
}
/*---------------------------------------------------------------------------//
 RollOvers and RollOuts for all buttons.
//---------------------------------------------------------------------------*/
gui.stopBtn.onRollOver =
gui.prevBtn.onRollOver =
gui.nextBtn.onRollOver =
gui.viewBtn.onRollOver = function () {
	b = this.icon;
	iconColor();
}
gui.playPauseBtn.onRollOver = function () {
	this.playIcon._visible != false ? b = this.playIcon : b = this.pauseIcon;
	iconColor();
}
gui.methodBtn.onRollOver = function() {
	switch(playmethod) {
		case "single":  b = this.singleIcon;  break;
		case "loop":    b = this.loopIcon;    break;
		case "list":    b = this.listIcon;    break;
		case "shuffle":	b = this.shuffleIcon; break;
	}
	iconColor();
	gui.tt._visible = true;
}
gui.playPauseBtn.onRollOut = gui.playPauseBtn.onReleaseOutside =
gui.stopBtn.onRollOut = gui.stopBtn.onReleaseOutside =
gui.prevBtn.onRollOut = gui.prevBtn.onReleaseOutside =
gui.nextBtn.onRollOut = gui.nextBtn.onReleaseOutside =
gui.methodBtn.onRollOut = gui.methodBtn.onReleaseOutside = 
gui.viewBtn.onRollOut = gui.viewBtn.onReleaseOutside = function () {
	iconColor("out");
	gui.tt._visible = false;
}
iconColor = function (out) {
	x = new Color(b);
	out == "out" ? x.setRGB(color3) : x.setRGB(color4);
}